﻿#ifndef __TDR_OCR_INCLUDE
#define __TDR_OCR_INCLUDE

#include <string>
#include <opencv2/core.hpp>

using namespace std;
//using namespace cv;

#ifdef _WIN32
#define EXPORTAPI _declspec(dllexport)
#else
#define EXPORTAPI
#endif

EXPORTAPI  void tdrocr_unInit();
EXPORTAPI  int tdrocr_init(const char* dir, const char* opt, int rect_number);
EXPORTAPI void tdr_set_log_file(const char * filename);
EXPORTAPI double tdr_get_current_time();  //unit is millisecond
EXPORTAPI void setDebugShow(int debug);
EXPORTAPI bool isDebugShow();
EXPORTAPI void tdr_set_log_dummy(int onoff);

typedef struct BOX_RESULT{
        int image_id; //图片的序号
	std::string result_txt; // 识别出的文字
	int valid; // 识别的结果是否正确，正确=1， 错误=0
        std::vector<cv::Point> boxPoint;
}BOX_RESULT;


EXPORTAPI int crnn_ocr(cv::Mat & src,
	int maxSideLen,
	int minHeight, int maxHeight,
	int minWidth, int maxWidth,
	float box_confidence,
	char * key,
	char * regex_key,
	std::vector<BOX_RESULT>& result
);

EXPORTAPI int crnn_ocr_batch(vector<cv::Mat> & src,
        int maxSideLen,
        int minHeight, int maxHeight,
        int minWidth, int maxWidth,
        float box_confidence,
        char * key,
        char * regex_key,
        vector<BOX_RESULT> & result
);

enum {
  ERROR_INI_FILE_ERROR = -1,
  ERROR_INI_SESSIOn_ERROR = -2
  
};


// 至少执行一次此初始化
// ini_pathname: 初始化文件路径名
// key_name: key的中文标识名
// return:  <0 出错
EXPORTAPI int ResetKeyParam(char *ini_pathname, char *key_name);

// image: 输入识别的图像
// result: 返回结果， 每个box内文字识别的结果
// return: <0 出错， >0 识别的正确的个数
EXPORTAPI int ScanImage(cv::Mat &image, std::vector<BOX_RESULT> &result);


//#define SUPPORT_GAMMA


#endif
